#!/bin/bash
data=$1
data_sgd_dir="simpleNN/experiment/logs/sgd"
data_newton_dir="simpleNN/experiment/logs/newton"

bsize="128"
C="0-01"
lr="0-003"
if [[ ${data} = "smallNORB-32x32" ]]
then
	lr="0-001"
fi
epoch_max="500"
iter_max="100"
mnt="0-9"
decay="6"
SR="0-05"
lambda="1"

g++ getplot_lr.cpp -o getplot_lr
filename1="${data_sgd_dir}/${data}-layer3-bsize-${bsize}-C-${C}-lr-${lr}-epoch-${epoch_max}-mnt-${mnt}-decay-${decay}-whole" 
./getplot_lr ${filename1}.log ${filename1}.txt
filename2="${data_sgd_dir}/${data}-layer3-bsize-${bsize}-C-${C}-lr-${lr}-epoch-${epoch_max}-mnt-0-decay-0-whole" 
./getplot_lr ${filename2}.log ${filename2}.txt

g++ getplot.cpp -o getplot
filename3="${data_newton_dir}/${data}-layer3-SR-${SR}-C-${C}-lambda-${lambda}-iter-${iter_max}-whole"
./getplot ${filename3}.log ${filename3}.txt


plot_command="plot "
plot_command="${plot_command} \"${filename1}.txt\" using 6:4 with linespoints lt rgb \"red\" lw 2 title \"SG-with-momentum\", "
plot_command="${plot_command} \"${filename2}.txt\" using 6:4 with linespoints lt rgb \"green\" lw 2 title \"SG-without-momentum\", "
plot_command="${plot_command} \"${filename3}.txt\" using 7:5 with linespoints lt rgb \"brown\" lw 2 title \"Newton\""

## PLOT ###
xrange="set autoscale x"
yrange="set autoscale y"
if [[ ${data} = "mnist" ]]
then
	xrange="set xrange [0:2500]"
	yrange="set yrange [0:100]"
fi
if [[ ${data} = "cifar10" ]]
then
	xrange="set xrange [0:20000]"
	yrange="set yrange [0:80]"
fi
if [[ ${data} = "smallNORB-32x32" ]]
then
	xrange="set xrange [0:2500]"
	yrange="set yrange [0:100]"
fi
if [[ ${data} = "SVHN" ]]
then
	xrange="set xrange [0:15000]"
	yrange="set yrange [0:100]"
fi

gnuplot <<- EOF
set datafile separator " -"
set xlabel "Time in seconds" font ",23" offset 0,-1
set ylabel "Test accuracy (%)" font ",23"
set xtics font ",17" offset 0,-0.2
set ytics font ",17" offset 0.5,0
set lmargin at screen 0.10
set rmargin at screen 0.95
set bmargin at screen 0.15
set tmargin at screen 0.95
${xrange}
${yrange}
set key reverse
set key bottom right Left
set key font ",17"
set key spacing 1.3
set terminal postscript eps enhanced color
set output "graph/${data}-time-test-acc-whole.eps"
${plot_command}
EOF
