function [results, acc] = cnn_predict_me(y, Z, model, param, idx_pad, idx_phiZ, idx_phiZ_pool)

addpath(genpath('./cnn'), genpath('./opt'));

%param = model.param;
%prob = check_data(y, Z, param);
%net = init_net(param, model);

%results = predict(prob, param, model, net);
% Rearrange data from the shape of l x abd to the shape of dab x l

L = param.L;
LC = param.LC;
%l = prob.l;
l = length(y);
l_batch = floor(param.SR * l);  % Regular batch size for each pipeline iteration
results = zeros(param.nL, l);

net.Z = cell(L+1, 1);
net.phiZ = cell(LC, 1);

net.idx_pad = idx_pad;
net.idx_phiZ = idx_phiZ;
net.idx_phiZ_pool = idx_phiZ_pool;

ed = 0;
for i = 1 : ceil(1/param.SR)
    st = ed + 1;
    ed = min(l, ed + l_batch);
    batch_idx = [st:ed];

    %net = feedforward(prob.data(:, batch_idx), param, model, net);
    data = Z(:,batch_idx);

	net.num_sampled_data = size(data, 2);
	net.Z{1} = reshape(data, model.ch_input(1), []);

	for m = 1 : LC
		net.phiZ{m} = padding_and_phiZ(model, net, m);
		net.Z{m+1} = max(model.weight{m}*net.phiZ{m} + model.bias{m}, 0);
		if model.wd_subimage_pool(m) > 1
			[net.Z{m+1}, net.idx_pool{m}] = maxpooling(model, net, m);
		end
	end

	dab = model.ch_input(LC+1) * model.wd_input(LC+1) * model.ht_input(LC+1);
	net.Z{LC+1} = reshape(net.Z{LC+1}, dab, []);

	for m = LC+1 : L-1
		net.Z{m+1} = max(model.weight{m}*net.Z{m} + model.bias{m}, 0);
	end

	net.Z{L+1} = model.weight{L}*net.Z{L} + model.bias{L};

    results(:, batch_idx) = net.Z{L+1};
end

% Obtain predicted label
[~, results] = max(results, [], 1);
results = results';

% Calculate accuracy
acc = sum(results == y) / length(y);

