function experiment(config_file, datapath, datapath_t, d, a, b, options)

if nargin == 6
    options = '';
end 
addpath(genpath('../'));

%% Train
% ------
% Read train data sets
[y, Z] = libsvmread(datapath);
y = y - min(y) + 1;
Z = [full(Z) zeros(size(Z,1), a*b*d - size(Z,2))];

% Rearrange data from row-wise to col-wise
Z = reshape(permute(reshape(Z, [],b,a,d), [1,3,2,4]), [], a*b*d);

% Max-min normalization
tmp_max = max(Z, [], 2);
tmp_min = min(Z, [], 2);
Z = (Z - tmp_min) ./ (tmp_max - tmp_min);

% Zero mean
mean_tr = mean(Z);
Z = Z - mean_tr;

%test
[y_t, Z_t] = libsvmread(datapath_t);
y_t = y_t - min(y_t) + 1;
Z_t = [full(Z_t) zeros(size(Z_t,1), a*b*d - size(Z_t,2))];

Z_t = reshape(permute(reshape(Z_t, [],b,a,d), [1,3,2,4]), [], a*b*d);

tmp_max = max(Z_t, [], 2);
tmp_min = min(Z_t, [], 2);
Z_t = (Z_t - tmp_min) ./ (tmp_max - tmp_min);

Z_t = Z_t - mean_tr;

model = cnn_train(y, Z, config_file, options, 111, y_t, Z_t);

