#!/bin/bash
mkdir -p logs/sgd
matlab="/usr/local/MATLAB/R2018a/bin/matlab"
batch_size="128"
epoch_max="500"
mnt="0.9"
mnt_label="0-9"
decay="6"

data="cifar10"
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 3, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max} -momentum ${mnt} -decay 1e-${decay}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-${mnt_label}-decay-${decay}-whole.log
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 3, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-0-decay-0-whole.log
data="mnist"
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 1, 28, 28, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max} -momentum ${mnt} -decay 1e-${decay}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-${mnt_label}-decay-${decay}-whole.log
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 1, 28, 28, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-0-decay-0-whole.log
data="smallNORB-32x32"
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 2, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.001 -epoch_max ${epoch_max} -momentum ${mnt} -decay 1e-${decay}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-001-epoch-${epoch_max}-mnt-${mnt_label}-decay-${decay}-whole.log
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 2, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.001 -epoch_max ${epoch_max}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-001-epoch-${epoch_max}-mnt-0-decay-0-whole.log
data="SVHN"
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 3, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max} -momentum ${mnt} -decay 1e-${decay}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-${mnt_label}-decay-${decay}-whole.log
${matlab} -nodesktop -nosplash -r "experiment('config/${data}-layer3.config', 'data/${data}', 'data/${data}.t', 3, 32, 32, '-s 2 -C 0.01 -bsize ${batch_size} -lr 0.003 -epoch_max ${epoch_max}'); exit;" > logs/sgd/${data}-layer3-bsize-${batch_size}-C-0-01-lr-0-003-epoch-${epoch_max}-mnt-0-decay-0-whole.log

