function model = sgd(prob, param, model, net)

lr = param.lr;
batch_size = param.bsize;
decay = param.decay;

v = cell(param.L,1);
v(:) = {0};

step = 1;

for k = 1 : param.epoch_max
    start = tic;
	for j = 1 : ceil(prob.l/batch_size) 
		batch_idx = randsample(prob.l, batch_size);
		[net, loss] = lossgrad_subset(prob, param, model, net, batch_idx, 'fungrad');
		for m = 1 : param.L
			Grad = [net.dlossdW{m} net.dlossdb{m}]/batch_size;                    
			Grad = Grad + [model.weight{m} model.bias{m}]/param.C;
			v{m} = param.momentum*v{m} - lr*Grad;
			model.weight{m} = model.weight{m} + v{m}(:,1:end-1);
			model.bias{m} = model.bias{m} + v{m}(:,end);
		end
		lr = param.lr/(1 + decay*step);
		step = step + 1;
	end
    iter_time = toc(start);

	[~, test_acc] = cnn_predict(prob.y_t, prob.data_t, model, param, net.idx_pad, net.idx_phiZ, net.idx_phiZ_pool);
	[~, train_acc] = cnn_predict(prob.y, prob.data, model, param, net.idx_pad, net.idx_phiZ, net.idx_phiZ_pool);

	fprintf('%d-epoch loss: %g train_acc: %g test_acc: %g time: %g\n', k, loss/batch_size, train_acc, test_acc, iter_time);
    start = tic;
end

model.param = param;
