import argparse
import dispatcher
import logparse

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Dispatcher')
    parser.add_argument('--host',
                        type=str,
                        metavar='host configuration',
                        help='Specify hosts configuration file')
    parser.add_argument(
        '--out_filename',
        type=str,
        metavar='output filename',
        help='Specify the filename storing the selected learning rate')
    args = parser.parse_args()

    newton_log = 'logs/exp1_newton.log'
    sg_log = 'logs/exp1_sg.log'

    dispatcher.dispatch(args.host, 'config/exp1_newton.config', newton_log)
    dispatcher.dispatch(args.host, 'config/exp1_sg.config', sg_log)

    res = {}
    res = logparse.get_exp1_newton_results(newton_log)
    res = logparse.get_exp1_sg_results(sg_log, res)

    logparse.print_exp1_results(res, args.out_filename)
    #logparse.print_exp1_ancillary_results(res, args.out_filename)
