import argparse
import dispatcher
import logparse

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Dispatcher')
    parser.add_argument('--host',
                        type=str,
                        metavar='host configuration',
                        help='Specify hosts configuration file')
    parser.add_argument('--cv_splits',
                        type=int,
                        metavar='# CV folds',
                        required=True,
                        help='Specify the # CV folds')
    args = parser.parse_args()

    CV_output_log = 'logs/CV_out.log'
    CV_result_log = 'logs/CV_result.log'
    job_config = 'config/exp1_sg_CV.config'
    dispatcher.dispatch(args.host, job_config, CV_output_log)

    best_lr, num_corrects, num_instances = logparse.get_CV_results(
        CV_output_log, args.cv_splits)
    logparse.print_CV_results(best_lr, num_corrects, num_instances,
        CV_result_log)
