#!/bin/bash

EXP_HOME='/tmp2/r04944005/matlab_experiment'
jobs_config_path='../config/exp1_sg_CV.config'
rm -f $jobs_config_path

channel=(2 1 3 3)
dataset_name=('smallNORB-32x32' 'mnist' 'cifar10' 'SVHN')
width=(32 28 32 32) 
lr_candidates=(0.003 0.001 0.0003 0.0001)
seed=111
cv_splits=5
for data in ${dataset_name[@]}
do
	config_3layer+=("../config/${data}-layer3.config")
	config_5layer+=("../config/${data}-layer5.config")
	dataset_train+=("../data/${data}")
done

for ((i = 0; i < ${#dataset_train[@]}; i++))
do
    for lr in ${lr_candidates[@]}
    do
        for ((cv_id=1;cv_id<=$cv_splits;cv_id++))
        do
            echo "cd $EXP_HOME; matlab -nodesktop -nosplash -r \\\"cross_validation('${config_5layer[$i]}', '${dataset_train[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '-s 2 -lr $lr -decay 1e-6 -momentum 0.9 -epoch_max 1000', $seed, '-v 5 -cv_id $cv_id'); exit;\\\"" >> $jobs_config_path
        done
    done
done

for ((i = 0; i < ${#dataset_train[@]}; i++))
do
    for lr in ${lr_candidates[@]}
    do
        for ((cv_id=1;cv_id<=$cv_splits;cv_id++))
        do
            echo "cd $EXP_HOME; matlab -nodesktop -nosplash -r \\\"cross_validation('${config_3layer[$i]}', '${dataset_train[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '-s 2 -lr $lr -decay 1e-6 -momentum 0.9 -epoch_max 1000', $seed, '-v 5 -cv_id $cv_id'); exit;\\\"" >> $jobs_config_path
        done
    done
done

