#!/bin/bash

EXP_HOME="/tmp2/r04944005/matlab_experiment"
output_newton_config="../config/exp1_newton.config"
output_sg_config="../config/exp1_sg.config"
rm -f $output_newton_config $output_sg_config

channel=(2 1 3 3)
dataset_name=('smallNORB-32x32' 'mnist' 'cifar10' 'SVHN')
width=(32 28 32 32)
lr_3layer=(0.003 0.001 0.003 0.003)
lr_5layer=(0.003 0.001 0.0003 0.003)
for data in ${dataset_name[@]}
do
        config_3layer+=("../config/${data}-layer3.config")
        config_5layer+=("../config/${data}-layer5.config")
        dataset_train+=("../data/${data}")
        dataset_test+=("../data/${data}.t")
done

# Newton 3-layer exp
for ((i = 0; i < ${#dataset_train[@]}; i++))
do
	for seed in {1..5}
	do
		echo "cd $EXP_HOME; matlab -r \\\"experiment('${config_3layer[$i]}', '${dataset_train[$i]}', '${dataset_test[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '', $seed); exit;\\\"" >> $output_newton_config
	done
done

# Newton 5-layer exp
for ((i = 0; i < ${#dataset_train[@]}; i++))
do
	for seed in {1..5}
	do
		echo "cd $EXP_HOME; matlab -r \\\"experiment('${config_5layer[$i]}', '${dataset_train[$i]}', '${dataset_test[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '', $seed); exit;\\\"" >> $output_newton_config
	done
done

# SG 3-layer exp
for ((i = 0; i < ${#dataset_train[@]}; i++))
do
  for seed in {1..5}
  do
    echo "cd $EXP_HOME; matlab -r \\\"experiment('${config_3layer[$i]}', '${dataset_train[$i]}', '${dataset_test[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '-s 2 -lr ${lr_3layer[$i]} -decay 1e-6 -momentum 0.9 -epoch_max 1000', $seed); exit;\\\"" >> $output_sg_config
  done
done

# SG 5-layer exp
for ((i = 0; i < ${#dataset_train[@]}; i++))
do
  for seed in {1..5}
  do
    echo "cd $EXP_HOME; matlab -r \\\"experiment('${config_5layer[$i]}', '${dataset_train[$i]}', '${dataset_test[$i]}', ${channel[$i]}, ${width[$i]}, ${width[$i]}, '-s 2 -lr ${lr_5layer[$i]} -decay 1e-6 -momentum 0.9 -epoch_max 1000', $seed); exit;\\\"" >> $output_sg_config
  done
done

