#!/bin/bash
matlab="/usr/local/MATLAB/R2018a/bin/matlab"

dataname=$1
if [[ ${dataname} = "mnist" ]]
then
    d="1"
    a="28"
    b="28"
elif [[ ${dataname} = "cifar10" ]]
then
    d="3"
    a="32"
    b="32"
elif [[ ${dataname} = "smallNORB-32x32" ]]
then
    d="2"
    a="32"
    b="32"
elif [[ ${dataname} = "SVHN" ]]
then
    d="3"
    a="32"
    b="32"
else
    echo "Input data can not be recognized."
fi

lambda="1"
lambdalabel="1"
iter_max="100"
SR_arr=("0.1" "0.05" "0.01")
SRlabel_arr=("0-1" "0-05" "0-01")
C_arr=("0.01" "0.1" "1")
Clabel_arr=("0-01" "0-1" "1")
seed_arr=("1" "2" "3" "4" "5")
seedlabel_arr=("1" "2" "3" "4" "5")

for (( k = 0 ; k < ${#C_arr[@]}; k++))
do
    for (( j = 0 ; j < ${#SR_arr[@]}; j++))
    do
        for (( m = 0 ; m < ${#seed_arr[@]}; m++))
        do
		${matlab} -nodesktop -nosplash -r "experiment('config/${dataname}-layer3.config', 'data/${dataname}', 'data/${dataname}.t', ${d}, ${a}, ${b}, '-s 1 -SR ${SR_arr[$j]} -C ${C_arr[$k]} -lambda ${lambda} -iter_max ${iter_max} -weight_name init_points/${dataname}_layer3_${seed_arr[$m]}.mat', ${seed_arr[$m]}); exit;" > logs/newton/${dataname}-layer3-SR-${SRlabel_arr[$j]}-C-${Clabel_arr[$k]}-lambda-${lambdalabel}-iter-${iter_max}-seed-${seedlabel_arr[$m]}.log
        done
    done
done

