#!/bin/bash
mkdir -p logs/sgd
matlab="/usr/local/MATLAB/R2018a/bin/matlab"

dataname=$1
if [[ ${dataname} = "mnist" ]]
then
	d="1"
	a="28"
	b="28"
elif [[ ${dataname} = "cifar10" ]]
then
	d="3"
	a="32"
	b="32"
elif [[ ${dataname} = "smallNORB-32x32" ]]
then
	d="2"
	a="32"
	b="32"
elif [[ ${dataname} = "SVHN" ]]
then
	d="3"
	a="32"
	b="32"
else
	echo "Input data can not be recognized."
fi

bsize="128"
bsize_label="128"
epoch_max="1000"
mnt="0.9"
mntlabel="0-9"
decay="1e-6"
decaylabel="6"
lr_arr=("0.1" "0.03" "0.01" "0.003" "0.001" "0.0003" "0.0001")
lrlabel_arr=("0-1" "0-03" "0-01" "0-003" "0-001" "0-0003" "0-0001")
C_arr=("0.01" "0.1" "1")
Clabel_arr=("0-01" "0-1" "1")
seed_arr=("1" "2" "3" "4" "5")
seedlabel_arr=("1" "2" "3" "4" "5")

for (( k = 0 ; k < ${#C_arr[@]}; k++))
do
	for (( j = 0 ; j < ${#lr_arr[@]}; j++))
	do
		for (( m = 0 ; m < ${#seed_arr[@]}; m++))
		do
			${matlab} -nodesktop -nosplash -r "experiment('config/${dataname}-layer3.config', 'data/${dataname}', 'data/${dataname}.t', ${d}, ${a}, ${b}, '-s 2 -bsize ${bsize} -C ${C_arr[$k]} -lr ${lr_arr[$j]} -epoch_max ${epoch_max} -momentum ${mnt} -decay ${decay} -weight_name init_points/${dataname}_layer3_${seed_arr[$m]}.mat', ${seed_arr[$m]}); exit;" > logs/sgd/${dataname}-layer3-bsize-${bsize_label}-C-${Clabel_arr[$k]}-lr-${lrlabel_arr[$j]}-epoch-${epoch_max}-mnt-${mntlabel}-decay-${decaylabel}-seed-${seedlabel_arr[$m]}-whole.log
		done
	done
done
